      SUBROUTINE JULCAL(MONTH,IDAY,IYEAR,JDAY)
C     JULCAL CALCULATES AND RETURNS THE CALENDAR DATE GIVEN THE JULIAN DAY AND
C  YEAR.  LEAP YEARS ARE ACCOUNTED FOR.
C
C  ARGUMENTS:
C    MONTH  - THE MONTH OF THE YEAR CALCULATED (AND RETURNED) BY JULCAL.
C    IDAY   - THE DAY OF THE MONTH CALCULATED (AND RETURNED) BY JULCAL.
C    IYEAR  - THE YEAR OF THE JULIAN DAY TO BE CONVERTED.
C    JDAY   - THE JULIAN DAY TO BE CONVERTED.
C
C  CONVERTED FROM THE IBM1800 SYSTEM BY PAUL HENKART, SCRIPPS INSTITUTION OF
C  OCEANOGRAPHY, 28 OCTOBER 1980
C
      DIMENSION MTHDY(12)
      DATA MTHDY/31,28,31,30,31,30,31,31,30,31,30,31/
C
      ISUM=0
C
C     CHECK FOR LEAP YEAR
C
c      IF(IYEAR-IYEAR/4*4)2,1,2
      IF(IYEAR-IYEAR/4*4 .EQ. 0 ) MTHDY(2)=29
C
C     SUM DAYS/ MONTH
C
2     DO 3 I=1,12
      ISUM=ISUM+MTHDY(I)
      ii = i
C
C     COMPARE AGAINST JULIAN DAY
C
c      IF(ISUM-JDAY) 3,4,4
      IF(ISUM-JDAY .GE. 0 ) GOTO 4
3     CONTINUE
C
C     JULIAN DAY FALLS WITHIN MONTH I, SO SUBTRACT OUT MONTH I FOR DATE
C
4     MONTH=II
      IDAY=JDAY+MTHDY(II)-ISUM
C
C     RESET LEAP YEAR COUNT
C
      MTHDY(2)=28
      RETURN
      END
